
function love.load()
  --create a thread named worker running the code in thread.lua
  thread = love.thread.newThread("worker", "thread.lua")
  --start the thread
  thread:start()
end


function love.update(dt)
  local imageData = thread:receive("progress")
  -- Only run this if it recieved something
  if imageData then
    image = love.graphics.newImage(imageData)
  end
end

function love.draw()
  if image then
    love.graphics.draw(image, 0,0)
  end
  local x,y = love.mouse.getPosition()
  love.graphics.circle("line",x,y,30,48)
end

function love.keypressed(k)
  -- Start the thread when spacebar is pressed
  if k==" " then
    --send the message to start
    thread:send("run", true)
  end
  if k=="q" then
    --send the message to quit
    thread:send("quit", true)
  end
end
